#include <QApplication>
#include <QWidget>
#include <QtGui>
#include <QFont>
#include <QSvgGenerator>

class MyWidget : public QWidget {
public:
  MyWidget(QWidget *parent = NULL) : QWidget(parent) {
   // setFixedSize(100, 100);
  }

protected:
  void paintEvent(QPaintEvent *) {

    int id = QFontDatabase::addApplicationFont(":/risorse/FreeSans.ttf");
    QString family = QFontDatabase::applicationFontFamilies(id).at(0);
    QFont f(family);

    f.setPixelSize(50);
    f.setUnderline(true);

    QPainterPath path;
    path.addText(50, 60, f, "pippo");

    QPainter painter(this);
    painter.setBrush(Qt::NoBrush);
    painter.setPen(Qt::SolidLine);
    painter.setRenderHint(QPainter::Antialiasing, true);
    painter.setRenderHint(QPainter::TextAntialiasing, true);
    painter.drawPath(path);
    f.setPixelSize(10);
    painter.setFont(f);
    painter.drawText(50, 80, "pippo");
    f.setPixelSize(20);
    painter.setFont(f);
    painter.drawText(50, 130, "pippo");
    f.setPixelSize(50);
    painter.setFont(f);
    painter.drawText(50, 200, "pippo");
    f.setPixelSize(100);
    painter.setFont(f);
    painter.drawText(50, 400, "pippo");

    f.setPixelSize(10);
    QSvgGenerator generator;
    generator.setFileName("./pippo.svg");
    generator.setSize(QSize(1000,1000));
    generator.setViewBox(QRect(0,0,1000,1000));
    QPainter painter2;
    painter2.begin(&generator);
    painter2.setFont(f);
    painter2.setBrush(Qt::NoBrush);
    painter2.setPen(Qt::SolidLine);
    painter2.setRenderHint(QPainter::Antialiasing, true);
    painter2.setRenderHint(QPainter::TextAntialiasing, true);
    painter2.drawPath(path);
    painter2.drawText(50, 80, "pippo");
    f.setPixelSize(20);
    painter2.setFont(f);
    painter2.drawText(50, 130, "pippo");
    f.setPixelSize(50);
    painter2.setFont(f);
    painter2.drawText(50, 200, "pippo");
    f.setPixelSize(100);
    painter2.setFont(f);
    painter2.drawText(50, 400, "pippo");
    painter2.end();

  }
};

int main(int argc, char **argv) {
  QApplication app(argc, argv);
  MyWidget w;
  w.show();
  return app.exec();
}
